﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class Bullet : MonoBehaviour
{
    [SerializeField] private float speed = 10;
    [SerializeField] private float distanceToExplode = 10;
    [SerializeField] private UnityEvent onExplode;
    [SerializeField] private GameObject explosion;
    
    private Rigidbody2D myRB;
    private Vector3 firstPose;
    
    void Start()
    {
        myRB = GetComponent<Rigidbody2D>();
        firstPose = transform.position;
    }

    // Update is called once per frame
    void Update()
    {
        myRB.MovePosition(transform.position + transform.right * speed * Time.deltaTime);
        if ((firstPose - transform.position).magnitude > distanceToExplode)
            Destroy(gameObject);
    }

    private void OnTriggerEnter2D(Collider2D other)
    {
        if (other.CompareTag("Explodable"))
        {
            Destroy(other.gameObject);
        }
        Explode();
    }

    private void Explode()
    {
        Instantiate(explosion, transform.position, Quaternion.identity);
        onExplode.Invoke();
        Destroy(gameObject);
    }
}
