﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Events;

public class PressButton : MonoBehaviour
{
    [SerializeField] private UnityEvent onPress;
    [SerializeField] private UnityEvent onRelease;

    private List<Collider2D> enteredObjects;
    
    void Start()
    {
        enteredObjects = new List<Collider2D>();
    }
    
    void Update()
    {
        
    }

    private void OnTriggerEnter2D(Collider2D other)
    {
        foreach (var col in enteredObjects)
        {
            if (col == null)
                enteredObjects.Remove(col);
        }
        if (other.CompareTag("Head") || other.CompareTag("UpPart") || other.CompareTag("Full") || other.CompareTag("Chest") || other.CompareTag("DeadParts"))
        {
            if (enteredObjects.Count == 0)
            {
                onPress.Invoke();
            }
            if (!enteredObjects.Exists(collider2D1 => { return other; }))
            {
                enteredObjects.Add(other);
            }
        }
    }

    private void OnTriggerExit2D(Collider2D other)
    {
        if (other.CompareTag("Head") || other.CompareTag("UpPart") || other.CompareTag("Full") ||
            other.CompareTag("Chest") || other.CompareTag("DeadParts"))
        {
            if (enteredObjects.Exists(collider2D1 => { return other; }))
            {
                enteredObjects.Remove(other);
            }
            
            if (enteredObjects.Count == 0)
            {
                onRelease.Invoke();
            }
        }
    }

    private void OnDestroy()
    {
        GetComponent<Collider2D>().enabled = false;
    }
}
